PRO FILL_BAND_DATA, band


  CASE band.shape OF
     'INSTR':BEGIN

        CASE band.instr OF

           ;; HFI_RIMO
           ;;----------
           'HFI_RIMO': BEGIN
              IF (band.version NE 'DX7-v1') AND $
                 (band.version NE 'DX8-v1') AND $
                 (band.version NE 'DX9-v1') AND $
                 ;; (band.version NE '20101213') AND $
                 ;; (band.version NE '20110412') AND $
                 ;; (band.version NE '20110720') AND $
                 ;; (band.version NE 'FFP4_bandpass-only') AND $
                 ;; (band.version NE '20120124') AND $
                 ;; (band.version NE 'FFP4_60s_weights_fcbp') AND $
                 ;; (band.version NE 'FFP4-v1') AND $
                 (band.version NE 'FFP4-v2') AND $
                 (band.version NE 'FFP6-v1') $
              THEN STOP

              rimofile = GETPSMDIR('psmdata')+'instrument/planck/RIMO/HFI/HFI_RIMO_'+band.version+'.fits'
              ok = TEST_PSM_DATA(rimofile, /get)
              IF NOT ok THEN ok = TEST_PSM_DATA(rimofile, /get, /private)
              IF NOT ok THEN MESSAGE, 'File missing: '+rimofile
              extension_name = 'BANDPASS_'+PSM_STR_REPLACE(band.channel,'_','-')
              bd = MRDFITS(rimofile,extension_name,/silent) 
              DEFSYSV, '!phyconst', exists=exists
              IF NOT exists THEN DEFINE_PHYSICAL_CONSTANTS
              nu = bd.wavenumber*100*!phyconst.c
              value = bd.transmission

                                ;loadct, 15
                                ;plot, nu, value, /xlog, /ylog, xrange=[1,3000]*1e9
          
              ;; restrict data to useful range
              IF PRECISION_ISDOUBLE() THEN wh = WHERE(value GE 1e-8, nwh) ELSE wh = WHERE(value GE 1e-3, nwh) 
              mi = MIN(wh) & ma = MAX(wh)
              nu = nu[mi:ma]
              value = value[mi:ma]

              ;;;;;;;quick fix
              wh_nu=where(nu ne 0)
              nu=nu[wh_nu]
              value=value[wh_nu]
              ;;;;;;;;/quick fix

                                ;oplot, nu, value, color=get_color('red')
                                ;stop

              band.data = PTR_NEW(GET_BAND_STRUCT('TABLE',nutab=nu, value=value))
              
           END

           ;; LFI_RIMO
           ;;----------
           'LFI_RIMO': BEGIN
              IF (band.version NE 'DX6-v1') AND $
                 (band.version NE 'DX7-v1') AND $
                 (band.version NE 'DX8-v1') AND $
                 (band.version NE 'DX9-v1') AND $
                 ;; (band.version NE 'FFP4_60s_weights_fcbp') AND $
                 ;; (band.version NE '03032011_DX6') AND $
                 ;; (band.version NE '03062011_DX7') AND $
                 ;; (band.version NE '30122011_DX8') AND $
                 (band.version NE 'FFP4-v1') AND $
                 (band.version NE 'FFP4-v2') AND $
                 (band.version NE 'FFP6-v1') $
             THEN MESSAGE, 'LFI Instrument version not available'

              rimofile = GETPSMDIR('psmdata')+'instrument/planck/RIMO/LFI/LFI_RIMO_'+band.version+'.fits'
              ok = TEST_PSM_DATA(rimofile, /get)
              IF NOT ok THEN ok = TEST_PSM_DATA(rimofile, /get, /private)
              IF NOT ok THEN MESSAGE, 'File missing: '+rimofile
              extension_name = 'BANDPASS_'+PSM_STR_REPLACE(band.channel,'_','-')
              bd = MRDFITS(rimofile,extension_name,/silent) 
              nu = bd.wavenumber*1e9
              value = bd.transmission>0
          
              ;; restrict data to useful range
              ;; IF PRECISION_ISDOUBLE() THEN wh = WHERE(value GE 1e-8, nwh) ELSE wh = WHERE(value GE 1e-3, nwh) 
              ;; mi = MIN(wh) & ma = MAX(wh)
              ;; nu = nu[mi:ma]
              ;; value = value[mi:ma]

              band.data = PTR_NEW(GET_BAND_STRUCT('TABLE',nutab=nu, value=value))
              
           END

           ;; IRAS_RIMO
           ;;-----------
           'IRAS_RIMO':BEGIN
              
              dirbands = GETPSMDIR('psmsoft')+'datafiles/IRAS/bands/'
              file2read = dirbands+'bandpass_'+band.channel+'s.txt'
              res =  FILE_TEST(file2read)
              IF res THEN READCOL, file2read, lambda, value, format='D,D', comment='#'
              DEFSYSV, '!phyconst', exists=exists
              IF NOT exists THEN DEFINE_PHYSICAL_CONSTANTS
              nu = !phyconst.c/lambda *1e6
              nu = nu(SORT(nu))
              value = value(SORT(nu))
              band.data = PTR_NEW(GET_BAND_STRUCT('TABLE',nutab=nu, value=value))

           END

           ELSE: BEGIN

              MESSAGE, 'Case not implemented'

              ;; CASE FIRSTCHAR(band.instr,3) OF
              ;;    'HFI': BEGIN
                    
              ;;       CASE band.version OF 
              ;;          'spencer_202': BEGIN
              ;;             ;; Where to find bandpass data
              ;;             ;;-----------------------------
              ;;             dirbands = GETPSMDIR('psmdata')+'instrument/planck/bands/bandpass_spencer_v2.02/SpecTransFiles_v202/'
                          
              ;;             datafile = 'HFI__bc*_'+band.channel+'_Apod5_v202.dat'
              ;;             ok = TEST_PSM_DATA(dirbands+datafile, /get)           
              ;;             IF ok THEN res = FILE_SEARCH(dirbands,'HFI__bc*_'+band.channel+'_Apod5_v202.dat') ELSE MESSAGE, 'Bandpass data file not available'
                          
              ;;             READCOL, res[0], wn, nu, value, error, flag, format='D,D,D,D,B', /silent
                          
              ;;                   ;loadct, 15
              ;;                   ;plot, nu, value, /xlog, /ylog, xrange=[1,3000]
                          
              ;;             IF PRECISION_ISDOUBLE() THEN wh = WHERE(value GE 1e-8, nwh) ELSE wh = WHERE(value GE 1e-3, nwh) 
              ;;             mi = MIN(wh) & ma = MAX(wh)
              ;;             nu = nu[mi:ma]
              ;;             value = value[mi:ma]
                          
              ;;                   ;oplot, nu, value, color=get_color('red')
              ;;                   ;stop
              ;;             band.data = PTR_NEW(GET_BAND_STRUCT('TABLE',nutab=nu*1e9, value=value))
              ;;          END
              ;;          ELSE: MESSAGE, 'Case not implemented'
              ;;       ENDCASE

              ;;    END
              ;; ENDCASE
           END
           
           
        ENDCASE
     END
  ENDCASE
  
END
