PRO INHOMOGENEOUS_REBEAMING, input_map=input_map,output_map=output_map,input_beam=input_beam,output_beam_map=output_beam_map

; All the inputs should be in ring format
;examples
;INHOMOGENEOUS_REBEAMING,input_map='k_band_foreground.fits',output_map='tmp5.fits',input_beam='beam_wmap5yr_k.txt',output_beam_map='beam_map_k.fits'


;Read Input and Output Beam Map
read_fits_map,input_map,inputmap
read_fits_map,output_beam_map,beam


;Read Pixels and convert them to angular coordinates
nside=512L
lmax=2*nside
npix=12*nside*nside
pixels=lindgen(npix)
thetas=fltarr(npix)
phis=fltarr(npix)
pix2ang_ring,nside,pixels,thetas,phis
thetas=  (.5*!PI - thetas)*180./!PI & phis=phis*180./!PI


mask=fltarr(npix)
selectmap=fltarr(npix)
finalmap=fltarr(npix)

startlat=0.
stoplat=5.
trans=5.0
bt=fltarr(lmax+1)

for i=0L,npix-1 do begin
selectmap(i)=0.0
endfor

for j=0,17 do begin
print,"Iteration Number",j
print,"Low Latitude is",startlat
print,"High Latitude is",stoplat
print,"--------------------------"



;Make Mask Map
;------------
for k=0L,npix-1 do begin
if(abs(thetas(k)) gt startlat  and abs(thetas(k)) le stoplat) then mask(k)= 1.0
if(thetas(k) gt 0 and abs(thetas(k)) gt stoplat and abs(thetas(k)) le stoplat+trans) then  mask(k)= COS(!pi*(thetas(k)-stoplat)/trans/2)^2
if( thetas(k) gt 0 and abs(thetas(k)) ge startlat-trans and abs(thetas(k)) le startlat)  then  mask(k)= COS(!pi*(thetas(k)-startlat)/trans/2)^2
if( thetas(k) le 0 and abs(thetas(k)) ge startlat-trans and abs(thetas(k)) le startlat)  then  mask(k)= COS(!pi*(thetas(k)-startlat)/trans/2)^2
if(thetas(k) le 0 and abs(thetas(k)) gt stoplat and abs(thetas(k)) le stoplat+trans) then  mask(k)= COS(!pi*(abs(thetas(k))-stoplat)/trans/2)^2
endfor


;calculate the alm from the masked map
maskmap=inputmap*mask
ianafast,maskmap,alm1_out='!alm.fits',nlmax=1024,ordering='ring',/cxx,/silent
fits2alm,index,alm_array,'alm.fits'


;calculate the fwhm from beam map

meanlat=(startlat+stoplat)/2.0
print,meanlat
lat=(.5*!PI) - (meanlat*!PI/180.0)
ang2pix_ring, nside,lat, 0.0, ipring
fwhm=beam(ipring)
print,fwhm,"FWHM"
b1=gaussbeam(fwhm(0),lmax+1)

s = SIZE(input_beam,/type)
;if input_beam in a file
IF type EQ 7 THEN readcol,input_beam,b2
;if input_beam is a number
IF type LE 5 THEN b2 = gaussbeam(input_beam,lmax+1)

lcut=n_elements(b2)-1


for l=0L,lmax do begin
if(l le lcut) then  bt[l]=b1[l]/b2[l]
if(l gt lcut) then  bt[l]=0.0
endfor

nn=n_elements(alm_array[*,0,0])

bb=fltarr(nn)
for i=0L,nn-1 do begin
   bb(i)=bt(LONG(SQRT(index[i]-1.D0)))

;   INDEX2L_ONLY, index(i), l
;   bb(i)=bt(l)
endfor

;Smooth the alm array

alm=alm_array
alm[*,0,0] = alm_array[*,0,0]*bb
alm[*,1,0] = alm_array[*,1,0]*bb

;alm to map conversion
almfile2='alm_tmp.fits'
alm2fits,index,alm,almfile2
smoothmap='smooth_map.fits'

    blank ="''" 
    print,'Generating CMB sky# = '
    openw,lun,'script',/get_lun 
    printf,lun,1 
    printf,lun,512
    printf,lun,1024
    printf,lun,blank
    printf,lun,-1
    printf,lun,0
    printf,lun,blank
    printf,lun,almfile2
    printf,lun,''
    printf,lun,blank
    printf,lun,smoothmap
    printf,lun,blank 
    free_lun,lun 
    spawn,'synfast < script' 


read_fits_map,smoothmap,selectmap
selectmap[where(mask ne 1.0)]=0.0
for i=0L,npix-1 do begin
if (finalmap(i) eq 0.0) then finalmap(i)=finalmap(i)+selectmap(i)
endfor

;mollview,finalmap,min=-0.3,max=0.3 
spawn,'rm -rf smooth_map.fits alm_tmp.fits alm.fits'

for i=0L,npix-1 do begin
mask(i)=0.0
endfor

startlat=startlat+5.0
stoplat=stoplat+5.0
endfor

;Write the new map file
write_fits_map,output_map,finalmap,coordsys='G',ordering='ring'
END


