FUNCTION PSM_BL_RATIO, beam1, beam2, lmax=lmax, double=double, dim=dim, help=help

  IF KEYWORD_SET(help) NE 0 THEN BEGIN
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     PRINT, 'PSM_BL_RATIO: function which returns the ratio of two beams in harmonic space (bl1/bl2)'
     PSM_INFO_MESSAGE, 'SYNTAX: result = PSM_BL_RATIO(beam1, beam2, lmax=, dim=, /double)'
     PSM_INFO_MESSAGE, 'set /double to force double precision for output'
     PSM_INFO_MESSAGE, 'beam1 and beam2 are structures for the first (numerator) and second (denominator) beams'
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     RETURN, 0
  ENDIF

  IF NOT DEFINED(double) THEN BEGIN
     double = PRECISION_ISDOUBLE()
  ENDIF

  bl1 = PSM_GET_BL(beam1,lmax=lmax,dim=dim,/double)
  bl2 = PSM_GET_BL(beam2,lmax=lmax,dim=dim,/double)

  IF double THEN RETURN, bl1/bl2 ELSE RETURN, FLOAT(bl1/bl2)

END
