FUNCTION CHANNELPARAM, instr, tag, ichan, help=help

  IF KEYWORD_SET(help) NE 0 THEN BEGIN
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     PRINT, 'CHANNELPARAM: function which returns the value of a tag for a channel in an instrument'
     PSM_INFO_MESSAGE, 'SYNTAX: result = CHANNELPARAM(instr, tag, ichan)'
     PSM_INFO_MESSAGE, 'instr is an instrument structure, created with LOAD_INSTRUMENT'
     PSM_INFO_MESSAGE, "tag is a string, the tag name of the parameter to return (example: 'band' or 'beam.size')"
     PSM_INFO_MESSAGE, "ichan is the channel number (starting at 1)"
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     RETURN, 0
  ENDIF

  ok = EXECUTE('res = instr.channel_'+NUMBER2STRING(ichan)+'.'+tag)
  IF NOT ok THEN BEGIN
     PSM_DEBUG_MESSAGE, 'Error in call to CHANNELPARAM function (wrong tag name)', routine='CHANNELPARAM', stoplimit=1
  ENDIF
  RETURN, res

END


