PRO ILENS, cmbalmfile, potalmfile, lcmbmapfile, $
           ulcmbmapfile=ulcmbmapfile, gradpotmapfile=gradpotmapfile, $
           ulclfile=ulclfile, lcmbclfile=lcmbclfile, $
           paramfile=paramfile, nside=nside, sigma=sigma, $
           kappa=kappa, polar=polar, method=method


PSM_DEBUG_MESSAGE, 'Check nside and lmax used', routine='ILENS', infolimit=2, stoplimit=3

IF SIZE(cmbalmfile,/TYPE) NE 7 THEN BEGIN
  PRINT, "cmbalmfile=", cmbalmfile
  PRINT, "cmbalmfile should be a string"
ENDIF

IF SIZE(potalmfile,/TYPE) NE 7 THEN BEGIN
  PRINT, "potalmfile=", potalmfile
  PRINT, "potalmfile should be a string"
ENDIF

IF SIZE(lcmbmapfile,/TYPE) NE 7 THEN BEGIN
  PRINT, "lcmbmapfile=", lcmbmapfile
  PRINT, "lcmbmapfile should be a string"
ENDIF

IF NOT KEYWORD_SET(ulcmbmapfile) THEN tmp_ulcmbmapfile=PSM_TMPFILENAME(extension='.fits')
IF NOT KEYWORD_SET(gradpotmapfile) THEN tmp_gradpotmapfile=PSM_TMPFILENAME(extension='.fits')
IF NOT KEYWORD_SET(ulcmbclfile) THEN tmp_ulcmbclfile=PSM_TMPFILENAME(extension='.fits')
IF NOT KEYWORD_SET(lcmbclfile) THEN tmp_lcmbclfile=PSM_TMPFILENAME(extension='.fits')

IF KEYWORD_SET(polar) THEN signal='ALL' ELSE signal='T'

IF NOT KEYWORD_SET(method) THEN method='nfft'

FITS2ALM, index, cmbalm, cmbalmfile, signal
pol=(N_ELEMENTS(cmbalm(0,0,*))-1)/2
nalm=N_ELEMENTS(cmbalm(*,0,0))
nlmax=NINT(SQRT(index(nalm-1)))-1L

FITS2ALM, index, potalm, potalmfile
potpol=(N_ELEMENTS(potalm(0,0,*))-1)/2
potnalm=N_ELEMENTS(potalm(*,0,0))

IF potpol NE 0 THEN BEGIN
  PRINT, "potpol=",potpol
  PRINT, "potpol should be equal to 0"
  STOP
ENDIF

IF potnalm NE nalm THEN BEGIN
  PRINT, "potnalm=",potnalm
  PRINT, "nalm=",nalm
  PRINT, "potnalm should be equal to nalm"
  STOP
ENDIF

IF NOT KEYWORD_SET(sigma) THEN sigma=2
IF NOT KEYWORD_SET(kappa) THEN kappa=4
IF NOT KEYWORD_SET(nside) THEN nside=2L^CEIL((ALOG10(nlmax)/ALOG10(2))-1.0)
IF NOT KEYWORD_SET(paramfile) THEN paramfile='ilens_params.ini' 

IF nlmax GE 3L*nside THEN MESSAGE, 'nside is too small'

;; OPENW, unit, paramfile,/GET_LUN
;; PRINTF, unit, STRTRIM(cmbalmfile,2)
;; PRINTF, unit, STRTRIM(potalmfile,2)
;; PRINTF, unit, STRTRIM(nside,2)
;; PRINTF, unit, STRTRIM(nlmax,2)
;; PRINTF, unit, STRTRIM(pol,2)
;; PRINTF, unit, STRTRIM(sigma,2)
;; PRINTF, unit, STRTRIM(kappa,2)
;; PRINTF, unit, STRTRIM(lcmbmapfile,2)
;; CLOSE, unit
;; FREE_LUN, unit


;; cmd='lensedmap '+paramfile

OPENW, unit, paramfile,/GET_LUN
PRINTF, unit, STRTRIM('input = '+'map',2)
PRINTF, unit, STRTRIM('cmbalmfile = '+cmbalmfile,2) 
PRINTF, unit, STRTRIM('potalmfile = '+potalmfile,2) 
PRINTF, unit, STRTRIM('nside = '+STRTRIM(nside,2),2)
PRINTF, unit, STRTRIM('nlmax = '+STRTRIM(nlmax,2),2)
PRINTF, unit, STRTRIM('pol = '+STRTRIM(pol,2),2)
PRINTF, unit, STRTRIM('sigma = '+STRTRIM(sigma,2),2)
PRINTF, unit, STRTRIM('kappa = '+STRTRIM(kappa,2),2)
IF NOT KEYWORD_SET(ulcmbmapfile) THEN PRINTF, unit, STRTRIM('ulcmbmapfile = '+tmp_ulcmbmapfile,2) $
                                 ELSE PRINTF, unit, STRTRIM('ulcmbmapfile = '+'!'+ulcmbmapfile,2)
IF NOT KEYWORD_SET(gradpotmapfile) THEN PRINTF, unit, STRTRIM('gradpotmapfile = '+tmp_gradpotmapfile,2) $
                                 ELSE PRINTF, unit, STRTRIM('gradpotmapfile = '+'!'+gradpotmapfile,2)
PRINTF, unit, STRTRIM('lcmbmapfile = '+'!'+lcmbmapfile,2)
IF NOT KEYWORD_SET(ulcmbclfile) THEN PRINTF, unit, STRTRIM('ulcmbclfile = '+tmp_ulcmbclfile,2) $
                                ELSE PRINTF, unit, STRTRIM('ulcmbclfile = '+'!'+ulcmbclfile,2)
IF NOT KEYWORD_SET(lcmbclfile) THEN PRINTF, unit, STRTRIM('lcmbclfile = '+tmp_lcmbclfile,2) $
                               ELSE PRINTF, unit, STRTRIM('lcmbclfile = '+'!'+lcmbclfile,2)
PRINTF, unit, STRTRIM('method = '+method,2)
CLOSE, unit
FREE_LUN, unit

SPAWN, 'getlensedmap '+paramfile

IF NOT KEYWORD_SET(ulcmbmapfile) THEN FILE_DELETE, tmp_ulcmbmapfile, /ALLOW_NONEXISTENT
IF NOT KEYWORD_SET(gradpotmapfile) THEN FILE_DELETE, tmp_gradpotmapfile, /ALLOW_NONEXISTENT
IF NOT KEYWORD_SET(ulcmbclfile) THEN FILE_DELETE, tmp_ulcmbclfile, /ALLOW_NONEXISTENT
IF NOT KEYWORD_SET(lcmbclfile) THEN FILE_DELETE, tmp_lcmbclfile, /ALLOW_NONEXISTENT


END


