FUNCTION FITSFILE_BAND, fitsfile, info_exists=info_exists, exten=exten

  PSM_DEBUG_MESSAGE, 'Read band in all extensions', routine = 'FITSFILE_BAND', infolimit=2, stoplimit=3
  IF NOT DEFINED(exten) THEN exten=1
  hd = HEADFITS(fitsfile, exten=exten)
  bandshape = STRTRIM(STRUPCASE(SXPAR(hd, 'BD_SHP', count=count)),2)

  info_exists = 1B

  IF count EQ 0 THEN BEGIN
     info_exists = 0B
     bandshape='UNKNOWN'
     band = GET_BAND_STRUCT('UNKNOWN')
  ENDIF

  CASE bandshape OF
     'DIRAC': BEGIN
        nu_c = SXPAR(hd,'BD_CNU')
        band = GET_BAND_STRUCT(bandshape,nu_c=nu_c)
     END
     'TOPHAT': BEGIN
        nu_min = SXPAR(hd,'BD_LNU')
        nu_max = SXPAR(hd,'BD_UNU')
        band = GET_BAND_STRUCT(bandshape,nu_min=nu_min,nu_max=nu_max)
     END
     'TABLE': BEGIN
        MESSAGE, 'Case not implemented'
     END
     'INSTR': BEGIN
        instr = SXPAR(hd,'BD_INSTR')
        version = SXPAR(hd,'BD_VERS')
        channel = SXPAR(hd,'BD_CHANNEL')
        band = GET_BAND_STRUCT(bandshape,instr=instr, version=version, channel=channel)
     END
     ELSE: BEGIN
        band = GET_BAND_STRUCT('UNKNOWN')
        IF psm_carefulness() GE 1 THEN PSM_INFO_MESSAGE, 'Band info not found in file '+fitsfile
        IF psm_carefulness() GE 2 THEN BEGIN
           PSM_INFO_MESSAGE, 'Band info not found in file '+fitsfile
           PSM_INFO_MESSAGE, 'Stopping the execution.'
           STOP
        ENDIF
     ENDELSE
  ENDCASE

RETURN, band
END
