PRO READ_CL, fitsfile, cl, exten=exten, hdr=hdr, help=help

  IF KEYWORD_SET(help) NE 0 THEN BEGIN
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     PRINT, 'READ_CL: procedure to read a power spectrum cl from a fits file'
     PSM_INFO_MESSAGE, 'SYNTAX: READ_CL, fitsfile, cl, exten=, hdr='
     PSM_INFO_MESSAGE, 'output cl is a structure as created with cl_structure.pro'
     PSM_INFO_MESSAGE, 'exten is the extension to be read (exten=1 by default)'
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     RETURN
  ENDIF

  ON_ERROR, 2
  IF NOT KEYWORD_SET(exten) THEN exten=1
  ok = FILE_TEST(fitsfile)
  IF NOT ok THEN MESSAGE, 'Cl file does not exist'
  cl = MRDFITS(fitsfile,exten)
  hdr = HEADFITS(fitsfile, exten=exten)

END
