FUNCTION PSM_GETPAPERREF, bibcode

  CASE bibcode OF

     ;; PSM
     ;;-----

     ;; CMB
     ;;-----
 
     '2009A&A...493..835D': ref = 'Delabrouille J., Cardoso J.-F., Le Jeune M., Betoule M., Fay G., Guilloux F., 2009, A&A, 493, 835'      ;; WMAP NILC5
     '2009A&A...508...53B': ref = 'Basak S., Prunet S., Benabed K., 2009, A&A, 508, 53'                                                    ;; Lensing with ilens
     '2009ApJS..184..264E': ref = 'Elsner F., Wandelt B.D., 2009, ApJS, 184, 264'                                                          ;; Non-Gaussian CMB

     ;; SZ
     ;;----

     '2002ASPC..257...81D': ref = 'Delabrouille J., Melin J.-B., Bartlett J.G., 2002, ASPC, 257, 81'                                       ;; SZ simulations, dmb model
     '2005MNRAS.363...29D': ref = 'Dolag K., Hansen F.K., Roncarelli M., Moscardini L., 2005, MNRAS, 363, 29'                              ;; Hubble volume from Dolag
     '2006MNRAS.370.1309S': ref = 'Schaefer B.M., Pfrommer C., Bartelmann M., Springel V., Hernquist L., 2006, MNRAS, 370, 1309'           ;; N-Body+Hydro simulations
     '2010arXiv1007.1916P': ref = 'Piffaretti R., et al., 2010, arXiv, arXiv:1007.1916'                                                    ;; MCXC catalogue
     '2007ApJ...660..239K': ref = 'Koester, B.P., et al., 2007, ApJ, 660, 239'                                                             ;; MaxBCG clusters
     '2010arXiv1008.5376D': ref = 'De Boni C., et al., 2010, arXiv, arXiv:1008.5376'                                                       ;; Hydro layers up to z=0.25

     ;; Galaxy
     ;;--------

     '2008A&A...490.1093M': ref = 'Miville-Deschenes M.-A., et al., 2008, A&A, 490, 1093'                                                  ;; Analysis of WMAP data into 4 components
     '1999ApJ...524..867F': ref = 'Finkbeiner D.P., Davis M., Schlegel D.J., 1999, ApJ, 524, 867'                                          ;; Thermal dust intensity
     '2011A&A...526A.145F': ref = 'Fauvet, L., et al., 2011, A&A, 526, A145'                                                               ;; Galactic magnetic field for galactic polar

     ;; FIRB
     ;;------

     '2005ApJ...621....1G': ref = 'Gonzalez-Nuevo J., Toffolatti L., Argueso F., 2005, ApJ, 621, 1'                                        ;; FIRB simulation
     '2011A&A...536A..18P': ref = 'The Planck Collaboration, 2011, A&A, 536, A18  '                                                        ;; Planck Early paper

  ENDCASE
  RETURN, ref
END

PRO PSM_ADD2BIB, bibcode

    COMMON psm, param
    file = param.run.psm_biblio_file
    GET_LUN, unit

    newtextarray = ['']
    a=''

    exists = FILE_TEST(file)
    IF exists THEN BEGIN
       OPENR, unit, file
       WHILE NOT EOF(unit) DO BEGIN
          READF, unit, a
          newtextarray=[newtextarray,a]
       END
       CLOSE, unit
       FREE_LUN, unit
       
       nref = N_ELEMENTS(bibcode)
       textarray = STRARR(nref) & FOR i=0, nref-1 DO  textarray[i] = PSM_GETPAPERREF(bibcode[i])

       newtextarray = [newtextarray,textarray]
       newtextarray = newtextarray[1:*]
    ENDIF ELSE BEGIN
       nref = N_ELEMENTS(bibcode)
       newtextarray = STRARR(nref) 
       FOR i=0, nref-1 DO  newtextarray[i] = PSM_GETPAPERREF(bibcode[i])
    ENDELSE

    s = SORT(newtextarray)
    newtextarray = newtextarray[s]
    keep = UNIQ(newtextarray)
    newtextarray = newtextarray[keep]

    OPENW, unit, file
   
    FOR i=0, N_ELEMENTS(newtextarray)-1 DO PRINTF, unit, newtextarray[i]

    CLOSE, unit
    FREE_LUN, unit

END
