; Copyright 2007 Observatoire de Paris

; This file is part of the Planck Sky Model.
;
; The Planck Sky Model is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; version 2 of the License.
;
; The Planck Sky Model is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY, without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with the Planck Sky Model. If not, write to the Free Software
; Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

;+
; print each field of a structure in a file
;
; @categories pipe
;   
; @param lun {in}{required} file unit
; @param st {required}{type=struct} the structure to print
;
; @uses 
; 
; @history <p>Created February 2007, Marc Betoule</p>
; @history <p>Improve the printing of list, March 19 2007, Marc Betoule</p>
;-
pro write_struct, lun, st
if not keyword_set(st) then return
tags = tag_names(st)
for i = 0, n_elements(tags)-1 do begin
    if n_elements(st.(i)) gt 1 then $
      val = fltarr2string(st.(i)) else $
      val = strtrim(string(st.(i),/print),2)
    printf, lun, strlowcase(tags[i]) + ' = ' + val
endfor
end
