PRO PSM_SEEDSTATUS, verbosity=verbosity, exists=exists, seedchain=seedchain

  IF NOT DEFINED(verbosity) THEN verbosity=GET_VERBOSITY()
  DEFSYSV, '!psm_seeds', exists=exists
  maxlen = LINE_LENGTH()

  IF verbosity NE 0 THEN BEGIN
     PRINT, PSM_STRING_TO_LENGTH('-',maxlen,character='-')
     DEFSYSV, '!psm_logfile', exists=existlog
     IF existlog THEN BEGIN
        GET_LUN, unit
        OPENU, unit, !psm_logfile, /append
        PRINTF, unit, PSM_STRING_TO_LENGTH('-',maxlen,character='-')
        CLOSE, unit
        FREE_LUN, unit
     ENDIF
  ENDIF
  IF NOT exists THEN BEGIN
     IF verbosity NE 0 THEN MESSAGE, 'Need to initialize the !psm_seeds system variable', /info
  ENDIF ELSE BEGIN
     seedchain = !psm_seeds.current.name
     IF verbosity NE 0 THEN PSM_INFO_MESSAGE, 'STATUS OF THE !PSM_SEEDS SYSTEM VARIABLE'
     IF verbosity NE 0 THEN PRTSTRUCT, !psm_seeds.current, name = '!PSM_SEEDS.CURRENT'
     IF verbosity GE 2 THEN BEGIN
        PRINT, PSM_STRING_TO_LENGTH('-',maxlen,character='-')
        DEFSYSV, '!psm_logfile', exists=exists
        IF existlog THEN BEGIN
           GET_LUN, unit
           OPENU, unit, !psm_logfile, /append
           PRINTF, unit, PSM_STRING_TO_LENGTH('-',maxlen,character='-')
           CLOSE, unit
           FREE_LUN, unit
        ENDIF
        wh = WHERE(!psm_seeds.chain_name NE '', nwh)
        PSM_INFO_MESSAGE, NUMBER2STRING(nwh) + ' EXISTING CHAINS'
        maxlen = MAX(STRLEN(!psm_seeds.chain_name))
        FOR i=0, nwh-1 DO PSM_INFO_MESSAGE, PSM_STRING_TO_LENGTH(!psm_seeds.chain_name[wh[i]],maxlen) + $
                                            ' : chain # '+ PSM_STRING_TO_LENGTH(NUMBER2STRING(wh[i]),4,/leading) + '  --- current seed value = ' + NUMBER2STRING(!psm_seeds.chain_value[wh[i]])
     ENDIF

  ENDELSE
  IF verbosity NE 0 THEN BEGIN
     PRINT, PSM_STRING_TO_LENGTH('-',maxlen,character='-')
     IF existlog THEN BEGIN
        GET_LUN, unit
        OPENU, unit, !psm_logfile, /append
        PRINTF, unit, PSM_STRING_TO_LENGTH('-',maxlen,character='-')
        CLOSE, unit
        FREE_LUN, unit
     ENDIF
  ENDIF
END
