PRO SOURCES_DISTRIBUTION, band, threshold, double=double, no_ir=no_ir, no_radio=no_radio, no_hii=no_hii


  nside=512
  map=dblarr(nside2npix(nside))

  pointer_map = PTR_NEW(map,/no_copy)

  ;; Read the catalogs
  ;;---------------------------------------------------
  
  IF NOT KEYWORD_SET(no_ir) THEN BEGIN
     
   ;;strong ir sources

     filename= FIX_SEPARATOR(GETPSMDIR('ps')) + 'strong_irps.sav'
     READ_CATALOG, filename, cat1
     
     OBSERVE_MODEL_CAT, cat1, band, result1
     wh=WHERE(result1[*,0] GE threshold)
     IF wh[0] NE -1 THEN print_pix_sources, nside, pointer_map, (*cat1.lat.value)[wh],(*cat1.lon.value)[wh]


   ;;faint ir sources

     filename= FIX_SEPARATOR(GETPSMDIR('ps')) + 'faint_irps.sav'
     READ_CATALOG, filename, cat2 
    
     OBSERVE_MODEL_CAT, cat2, band, result2
     wh=WHERE(result2[*,0] GE threshold)

     IF wh[0] NE -1 THEN print_pix_sources, nside, pointer_map, (*cat2.lat.value)[wh],(*cat2.lon.value)[wh]

  ENDIF
  IF NOT KEYWORD_SET(no_radio) THEN BEGIN

   ;;strong radio sources
     
     filename= FIX_SEPARATOR(GETPSMDIR('ps')) + 'strong_radiops.sav'
     READ_CATALOG, filename, cat3

     OBSERVE_MODEL_CAT, cat3, band, result3
     wh=WHERE(result3[*,0] GE threshold)
     IF wh[0] NE -1 THEN print_pix_sources, nside, pointer_map, (*cat3.lat.value)[wh],(*cat3.lon.value)[wh]

   ;;faint radio sources

     filename= FIX_SEPARATOR(GETPSMDIR('ps')) + 'faint_radiops.sav'
     READ_CATALOG, filename, cat4
     OBSERVE_MODEL_CAT, cat4, band, result4
     wh=WHERE(result4[*,0] GE threshold)
     IF wh[0] NE -1 THEN print_pix_sources, nside, pointer_map, (*cat4.lat.value)[wh],(*cat4.lon.value)[wh]
     
  ENDIF
  IF NOT KEYWORD_SET(no_hii) THEN BEGIN
   ;;hii sources

    filename= FIX_SEPARATOR(GETPSMDIR('ps')) + 'strong_uchii.sav'
     READ_CATALOG, filename, cat5
     OBSERVE_MODEL_CAT, cat5, band, result5
     wh=WHERE(result5[*,0] GE threshold)
     IF wh[0] NE -1 THEN print_pix_sources, nside, pointer_map, (*cat5.lat.value)[wh],(*cat5.lon.value)[wh]
     
  ENDIF

  mollview, *pointer_map
stop
 ptr_free, pointer_map
  ;LOGN_LOGS, fluxes

END
