FUNCTION NILC5_WIENER_FILTER, ell, help=help

  IF KEYWORD_SET(help) NE 0 THEN BEGIN
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     PRINT, 'NILC5_WIENER_FILTER: function to get the Wiener Filter coefficients for the NILC5 CMB map of Delabrouille et al. (2008)'
     PSM_INFO_MESSAGE, 'SYNTAX: result = NILC5_WIENER_FILTER(ell)'
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     RETURN, 0
  ENDIF

  datafile = GETPSMDIR('psmdata')+'ancillary/observations/WMAP/NILC-CMB-5yr/beam_bl.txt'
  ok = TEST_PSM_DATA(datafile, /get)

  READCOL, datafile, l, b, bw, format='L,D,D', comment='#'
  l = l[0:1199]
  w = FLOAT(bw[0:1199]/b[0:1199])

  filter = FLTARR(N_ELEMENTS(ell))
  wh = WHERE(ell LE 1199, nwh)
  IF nwh NE 0 THEN filter[wh]=w[wh]
  RETURN, filter

END

