FUNCTION FIRB_DNDSDZ_LATE_TYPE, population

  IF (population NE 'SPIRAL') AND (population NE 'STARBURST') THEN BEGIN
     print, 'case not implemented. Please use either "SPIRAL" or "STARBURST" population'
     STOP
  ENDIF

  fname = GETPSMDIR('psmdata')+'ancillary/models/firb/GC-2012/'+'dNdlgSdz_spANDsb_250micron.fits'
  ok = TEST_PSM_DATA(fname, /get)
  IF NOT ok THEN MESSAGE, 'File not available: '+fname
  
  ;; counts are at 250microns
  ref_freq = !phyconst.c / 250e-6

  flux_units='mJy'
  counts_units='sr-1.dz-1.mJy-1'
  tab = mrdfits(fname, 1)
  
  fluxes = 10.^tab.lgf
  z=tab.z
 
  nz=n_elements(z)
  nfluxes=n_elements(fluxes)
  a_fluxes = dblarr(nfluxes,nz)
  FOR i=0, nz-1 DO a_fluxes[*,i]=fluxes

  CASE population OF
     'SPIRAL': BEGIN

        dndsdz = tab.DNDLGFDZ_SP*(180^2)/((!dpi^2)*a_fluxes*alog(10))

        dndlgsdz = tab.DNDLGFDZ_SP*(180^2)/(!dpi^2)
     END
     'STARBURST': BEGIN
        dndsdz = tab.DNDLGFDZ_SB*(180^2)/((!dpi^2)*a_fluxes*alog(10))
        dndlgsdz = tab.DNDLGFDZ_SB*(180^2)/(!dpi^2)
     END
  ENDCASE

  ;;put dimensions with redshift first and fluxes in second position
  dndsdz=transpose(TEMPORARY(dndsdz))
  dndlgsdz=transpose(dndlgsdz)

  counts={population:population, fluxes:fluxes, lg_fluxes:tab.lgf, flux_units:flux_units, lg_flux:'log10(fluxes)', redshifts:z, dndsdz:dndsdz, dndlgsdz:dndlgsdz, nuref:ref_freq, counts_units:counts_units}

return, counts

END
