PRO dl98_spin_dust_init

;Initialise emissivities for spinning dust grain model
;+
; NAME:
;    dl98_spin_dust_init
; CATEGORY:
;    Planck Sky Model
; PURPOSE:
;    Initialize system variables used by DL98 Spinning Dust Model
; CALLING SEQUENCE:
;    dl98_spin_dust_init
; INPUT:
;    None
; OUTPUT:
;    !sky_model IDL system variable (array of pointers) is updated
; OPTIONAL INPUT:
;    None
; INPUT KEYWORDS:
;    None
; OUTPUT KEYWORDS:
;    None
; SIDE EFFECTS:
;    The !sky_model IDL system variable is updated
; EXAMPLES:
;    dl98_spin_dust_init
; RESTRICTIONS:
;    The following unix system variables must be defined:
;    SPINNING_DUST_EM_DIR
; PROCEDURES CALLED:
;    readcol
; REVISION HISTORY:
;    Modified from spin_dust_init.pro by MAMD. C. Dickinson. 2-Jul-2007.
;-


dir = GETPSMDIR('psmsoft')+'datafiles/spindust/'

file=dir+'emit4.jnu.cnm_a'
readcol,file,freq_cnm,jnu_cnm,/silent

file=dir+'emit4.jnu.drk_a'
readcol,file,freq_drk,jnu_drk,/silent

file=dir+'emit4.jnu.mol_a'
readcol,file,freq_mol,jnu_mol,/silent

file=dir+'emit4.jnu.wim_a'
readcol,file,freq_wim,jnu_wim,/silent

file=dir+'emit4.jnu.wnm_a'
readcol,file,freq_wnm,jnu_wnm,/silent

file=dir+'emit4.jnu.rn_a'
readcol,file,freq_rn,jnu_rn,/silent

file=dir+'emit4.jnu.extra_a'
readcol,file,freq_extra,jnu_extra,/silent

jnu_freqs=freq_cnm

(*!sky_model).spinning_dust.dl98.jnu_cnm=ptr_new(jnu_cnm)
(*!sky_model).spinning_dust.dl98.jnu_wnm=ptr_new(jnu_wnm)
(*!sky_model).spinning_dust.dl98.jnu_wim=ptr_new(jnu_wim)
(*!sky_model).spinning_dust.dl98.jnu_mol=ptr_new(jnu_mol)
(*!sky_model).spinning_dust.dl98.jnu_drk=ptr_new(jnu_drk)
(*!sky_model).spinning_dust.dl98.jnu_rn=ptr_new(jnu_rn)
(*!sky_model).spinning_dust.dl98.jnu_extra=ptr_new(jnu_extra)
(*!sky_model).spinning_dust.dl98.jnu_freqs=ptr_new(jnu_freqs)


END
