; -----------------------------------------------------------------------------
;
; Copyright (C) 2009
;   Jacques Delabrouille
;   Jean-Baptiste Melin
;
; This file is part of the Planck Sky Model (PSM).
;
; The Planck Sky Model is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; The Planck Sky Model is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with the Planck Sky Model.  If not, see <http://www.gnu.org/licenses/>.
;
; For more information about the PSM see:
; http://www.apc.univ-paris7.fr/~delabrou/PSM/psm.html
; or contact Jacques Delabrouille (delabrouille@apc.univ-paris7.fr)
;
; -----------------------------------------------------------------------------
;+
;-
PRO CATALOG_DRAW_LONLAT, catalog, map_hd=map_hd, iseed=iseed

; This procedure is called in CREATE_SZ_SIMULATION in order to draw
; the exact cluster positions in their pixels  

IF NOT KEYWORD_SET(iseed) THEN iseed = LONG(systime(1))

nx = SXPAR(map_hd, 'NAXIS1')
ny = SXPAR(map_hd, 'NAXIS2')
dx = ABS(SXPAR(map_hd,'CDELT1'))
dy = ABS(SXPAR(map_hd,'CDELT2'))

lon_map = (FINDGEN(nx)-(nx-1.)/2.)#REPLICATE(dx,ny)
lat_map = REPLICATE(dy,nx)#(FINDGEN(ny)-(ny-1.)/2.)

nclu = N_ELEMENTS(catalog)

dlon = dx*(RANDOMU(iseed,nclu)-0.5)
dlat = dy*(RANDOMU(iseed,nclu)-0.5)

lon = lon_map[catalog.pixel]+dlon
lat = lat_map[catalog.pixel]+dlat

catalog.lon = lon
catalog.lat = lat

END  
