; -----------------------------------------------------------------------------
;
; Copyright (C) 2009
;   Jacques Delabrouille
;   Jean-Baptiste Melin
;
; This file is part of the Planck Sky Model (PSM).
;
; The Planck Sky Model is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; The Planck Sky Model is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with the Planck Sky Model.  If not, see <http://www.gnu.org/licenses/>.
;
; For more information about the PSM see:
; http://www.apc.univ-paris7.fr/~delabrou/PSM/psm.html
; or contact Jacques Delabrouille (delabrouille@apc.univ-paris7.fr)
;
; -----------------------------------------------------------------------------
;+
;-
PRO WRITE_SZ_MODEL_CAT, filename, cat, sz_header=sz_header, psm_header=psm_header

; Write the main catalogue
  MWRFITS, cat, filename, /CREATE
  hd=HEADFITS(filename, exten=1)

; Prepare the inclusion of a PSM header at the end
  array = ['COMMENT','COMMENT  *** PSM header ***','COMMENT']
  ln = STRLEN(hd[0])
  array = PSM_STRING_TO_LENGTH(array,ln)
  nhd = N_ELEMENTS(hd)
  hd = [hd[0:nhd-2],array,hd[nhd-1]]

; Include the sz_header information in the catalogue header
  tagnames = TAG_NAMES(sz_header)
  ntags = N_ELEMENTS(tagnames)
  FOR i=0, ntags-3 DO BEGIN
     cmd = "SXADDPAR, hd, '"+STRTRIM(tagnames[i],2)+"', '"+STRTRIM(sz_header.(i),2)+"'"
     ok=EXECUTE(cmd)
  ENDFOR

; Describe the fields in the catalogue header : name+units
  nfields = N_ELEMENTS(sz_header.fields)
  FOR i=0, nfields-1 DO BEGIN
     cmd = "SXADDPAR, hd, 'TTYPE"+STRTRIM(STRING(i+1),1)+"', SXPAR(hd,'TTYPE"+STRTRIM(STRING(i+1),1)+"'), '"+STRTRIM((sz_header.fields)[i],2)+" ["+STRTRIM(STRING((sz_header.units)[i]),2)+"]'"
     ok=EXECUTE(cmd)
  ENDFOR
  
  MODFITS, filename, 0, hd, exten=1

END


