PRO RUN_NONGAUSSIAN_CMB_CASE, resol, output_directory, fields, sky_pixwindow, cmb_lensing, ng_simuset, hi_ell_extend_gaussian, readjust_ng_spectrum, cmb_cl_source, r_ts=r_ts

  IF DEFINED(r_ts) THEN BEGIN
     r_is_0 = r_ts EQ 0
     r_is_005 = r_ts EQ 0.05
     ok = r_is_0 OR r_is_005
     IF NOT ok THEN MESSAGE, 'r_ts must be either 0 or 0.05 in this test'
  ENDIF

  PSM_INFO_MESSAGE, 'FIELDS = ' + fields
  PSM_INFO_MESSAGE, 'SKY_PIXWINDOW = ' + sky_pixwindow
  PSM_INFO_MESSAGE, 'CMB_LENSING = ' + cmb_lensing
  PSM_INFO_MESSAGE, 'NG_SIMUSET = ' + ng_simuset
  PSM_INFO_MESSAGE, 'HI_ELL_EXTEND_GAUSSIAN = ' + hi_ell_extend_gaussian
  PSM_INFO_MESSAGE, 'READJUST_NG_SPECTRUM = ' + readjust_ng_spectrum
  PSM_INFO_MESSAGE, 'CMB_CL_SOURCE = ' + cmb_cl_source
  IF KEYWORD_SET(r_ts) NE 0 THEN PSM_INFO_MESSAGE, 'R = ' + NUMBER2STRING(r_ts)
  
  GET_LUN, unit
  paramfile = PSM_TMPFILENAME(extension='.psm')
  OPENW, unit, paramfile
  PRINTF, unit, 'OUTPUT_DIRECTORY = ' + output_directory
  PRINTF, unit, 'FIELDS = ' + fields
  PRINTF, unit, 'CLEAR_ALL = yes'
  PRINTF, unit, 'VISU = 2'
  PRINTF, unit, 'OUTPUT_VISU = ps'
  PRINTF, unit, 'SKY_RESOLUTION = ' + NUMBER2STRING(resol)
  PRINTF, unit, 'SKY_LMAX = ' + NUMBER2STRING(RESOL2LMAX(resol))
  PRINTF, unit, 'SKY_PIXELISATION = HEALPIX'
  PRINTF, unit, 'HEALPIX_NSIDE = ' + NUMBER2STRING(RESOL2NSIDE(resol))
  PRINTF, unit, 'SKY_PIXWINDOW = ' + sky_pixwindow

  needed_cl = 0B
  IF readjust_ng_spectrum EQ 'yes' THEN needed_cl = 1B
  IF hi_ell_extend_gaussian EQ 'yes' THEN needed_cl = 1B
  IF r_ts NE 0 THEN needed_cl = 1B

  PRINTF, unit, 'RUN_CAMB = yes'
  IF needed_cl THEN BEGIN
     CASE cmb_cl_source OF
        'CAMB': 
        'CLASS': BEGIN
           PRINTF, unit, 'RUN_CLASS = yes'           
        END
        'standard-LCDM': 
     ENDCASE
  ENDIF

  PRINTF, unit, 'CMB_MODEL = nongaussian_fnl'
  PRINTF, unit, 'CMB_LENSING = ' + cmb_lensing
  PRINTF, unit, 'NG_SIMUSET = ' + ng_simuset
  PRINTF, unit, 'HI_ELL_EXTEND_GAUSSIAN = ' + hi_ell_extend_gaussian
  PRINTF, unit, 'READJUST_NG_SPECTRUM = ' + readjust_ng_spectrum
  
  IF READJUST_NG_SPECTRUM EQ 'yes' THEN BEGIN
     PRINTF, unit, 'H = 0.71'
     PRINTF, unit, 'OMEGA_B = 0.046'
     PRINTF, unit, 'OMEGA_M = 0.28'
     PRINTF, unit, 'TAU_REION = 0.095'
  ENDIF
  IF r_ts NE 0 THEN PRINTF, unit, 'R = '+NUMBER2STRING(r_ts)

  PRINTF, unit, 'OBS_TASK = new'
  PRINTF, unit, 'WHAT_OBS = bandinteg'
  PRINTF, unit, 'INSTRUMENT = PSM_IDEAL'
  PRINTF, unit, 'OBS_FREQUENCIES =  150'
  PRINTF, unit, 'OBS_STOKES = ' + fields


  CLOSE, unit
  FREE_LUN, unit
  PSM_MAIN, paramfile, /debug, verbosity=0

  IF GET_DEBUG() GE 2 THEN STOP ; check what happens to paramfile

END


PRO TEST_NONGAUSSIAN_CMB, resol=resol, r_ts=r_ts, $
                          nsample=nsample, $
                          exhaustive=exhaustive, pickruncase=pickruncase, $
                          fields=fields, sky_pixwindow=sky_pixwindow, cmb_lensing=cmb_lensing, $
                          ng_simuset=ng_simuset, hi_ell_extend_gaussian=hi_ell_extend_gaussian, readjust_ng_spectrum=readjust_ng_spectrum, $
                          cmb_cl_source=cmb_cl_source
  
  IF NOT KEYWORD_SET(resol) THEN resol=120         ; 120 arcminutes
  output_directory = GETPSMDIR('psmroot') + 'Test/PSM_OUTPUT_nongaussian_cmb_'
  
  listparam = ['FIELDS', 'SKY_PIXWINDOW', 'CMB_LENSING', 'NG_SIMUSET', 'HI_ELL_EXTEND_GAUSSIAN', 'READJUST_NG_SPECTRUM', 'CMB_CL_SOURCE', 'R_TS']
  
  fields_list = ['T','TP']
  sky_pixwindow_list = ['0','1']
  cmb_lensing_list = ['none','ilens']
  ng_simuset_list = ['elsner1024','elsner3500']
  hi_ell_extend_gaussian_list = ['yes', 'no']
  readjust_ng_spectrum_list = ['yes', 'no']
  cmb_cl_source_list = ['standard-LCDM', 'CAMB', 'CLASS']
  r_list = [0, 0.05]
  
  runcase=1L
  
  n1 = LONG(N_ELEMENTS(fields_list))
  n2 = LONG(N_ELEMENTS(sky_pixwindow_list))
  n3 = LONG(N_ELEMENTS(cmb_lensing_list))
  n4 = LONG(N_ELEMENTS(ng_simuset_list))
  n5 = LONG(N_ELEMENTS(hi_ell_extend_gaussian_list))
  n6 = LONG(N_ELEMENTS(readjust_ng_spectrum_list))
  n7 = LONG(N_ELEMENTS(cmb_cl_source_list))
  n8 = LONG(N_ELEMENTS(r_list))

  ncases = n1 * n2 * n3 * n4 * n5 * n6 * n7 * n8
           
  IF ((KEYWORD_SET(exhaustive)) OR (KEYWORD_SET(pickruncase))) THEN BEGIN

     FOR p8=0,n8-1 DO FOR p7=0,n7-1 DO FOR p6=0,n6-1 DO FOR p5=0,n5-1 DO FOR p4=0,n4-1 DO FOR p3=0,n3-1 DO FOR p2=0,n2-1 DO FOR p1=0,n1-1 DO BEGIN
        
        IF KEYWORD_SET(pickruncase) NE 0 THEN BEGIN
           IF runcase NE pickruncase THEN GOTO, nextcase
        ENDIF

        fields = fields_list[p1]
        sky_pixwindow = sky_pixwindow_list[p2]
        cmb_lensing = cmb_lensing_list[p3]
        ng_simuset = ng_simuset_list[p4]
        hi_ell_extend_gaussian = hi_ell_extend_gaussian_list[p5]
        readjust_ng_spectrum = readjust_ng_spectrum_list[p6]
        cmb_cl_source = cmb_cl_source_list[p7]
        r_ts = r_list[p8]
        

        PSM_INFO_TITLE, 'RUN CASE '+NUMBER2STRING(runcase)+': '
        
        output_directory_n = output_directory + NUMBER2STRING(runcase)
        
        RUN_NONGAUSSIAN_CMB_CASE, resol, output_directory_n, fields, sky_pixwindow, cmb_lensing, ng_simuset, hi_ell_extend_gaussian, readjust_ng_spectrum, cmb_cl_source, r_ts=r_ts
        
        nextcase:
        runcase = runcase + 1L
     ENDFOR

  ENDIF ELSE BEGIN

     casenumber = LINDGEN(ncases)+1L
     casenumber = REFORM(casenumber, n1, n2, n3, n4, n5, n6, n7, n8)
     i1 = casenumber & FOR i=0, n1-1 DO i1[i,*,*,*,*,*,*,*] = i
     i2 = casenumber & FOR i=0, n2-1 DO i2[*,i,*,*,*,*,*,*] = i
     i3 = casenumber & FOR i=0, n3-1 DO i3[*,*,i,*,*,*,*,*] = i
     i4 = casenumber & FOR i=0, n4-1 DO i4[*,*,*,i,*,*,*,*] = i
     i5 = casenumber & FOR i=0, n5-1 DO i5[*,*,*,*,i,*,*,*] = i
     i6 = casenumber & FOR i=0, n6-1 DO i6[*,*,*,*,*,i,*,*] = i
     i7 = casenumber & FOR i=0, n7-1 DO i7[*,*,*,*,*,*,i,*] = i
     i8 = casenumber & FOR i=0, n8-1 DO i8[*,*,*,*,*,*,*,i] = i

     IF NOT KEYWORD_SET(nsample) THEN nsample=1
     draw = RANDOMU(noseed,nsample)
     cases = LONG(ncases*draw)

     FOR i=0L, nsample-1 DO BEGIN
        IF NOT DEFINED(fields) THEN usei1 = i1[cases[i]] ELSE usei1 = (WHERE(fields_list EQ fields))[0]
        IF NOT DEFINED(sky_pixwindow) THEN usei2 = i2[cases[i]] ELSE usei2 =  (WHERE(sky_pixwindow_list EQ sky_pixwindow))[0]
        IF NOT DEFINED(cmb_lensing) THEN usei3 = i3[cases[i]] ELSE usei3 =  (WHERE(cmb_lensing_list EQ cmb_lensing))[0]
        IF NOT DEFINED(ng_simuset) THEN usei4 = i4[cases[i]] ELSE usei4 =  (WHERE(ng_simuset_list EQ ng_simuset))[0]
        IF NOT DEFINED(hi_ell_extend_gaussian) THEN usei5 = i5[cases[i]] ELSE usei5 =  (WHERE(hi_ell_extend_gaussian_list EQ hi_ell_extend_gaussian))[0]
        IF NOT DEFINED(readjust_ng_spectrum) THEN usei6 = i6[cases[i]] ELSE usei6 =  (WHERE(readjust_ng_spectrum_list EQ readjust_ng_spectrum))[0]
        IF NOT DEFINED(cmb_cl_source) THEN usei7 = i7[cases[i]] ELSE usei7 =  (WHERE(cmb_cl_source_list EQ cmb_cl_source))[0]
        IF NOT DEFINED(r_ts) THEN usei8 = i8[cases[i]] ELSE usei8 =  (WHERE(r_list EQ r_ts))[0]

        TEST_NONGAUSSIAN_CMB, resol=resol, pickruncase=casenumber[usei1,usei2,usei3,usei4,usei5,usei6,usei7,usei8]
     ENDFOR

  ENDELSE
  
END
