FUNCTION ARRAYS_EQUAL, a, b, typecheck=typecheck

  ;; same number of elements?
  na = N_ELEMENTS(a)
  nb = N_ELEMENTS(b)
  IF na NE nb THEN RETURN, 0B
  ;; compare all elements
  iseq = 1B
  FOR j=0L, na-1 DO BEGIN
     typa = SIZE(a[j],/type)
     typb = SIZE(b[j],/type)

     IF KEYWORD_SET(typecheck) NE 0 THEN IF typa NE typb THEN RETURN, 0B
     
     IF ((typa GE 9) OR (typb GE 9)) THEN BEGIN
        
        IF (typa EQ 10) AND (typb EQ 10) THEN BEGIN
           IF PTR_VALID(a[j]) AND PTR_VALID(b[j]) THEN BEGIN
              typaptd = SIZE(*(a[j]),/type)
              typbptd = SIZE(*(b[j]),/type)
              IF (typaptd EQ 8) AND (typbptd EQ 8) THEN BEGIN
                 IF NOT STRUCT_EQUAL(*(a[j]),*(b[j])) THEN RETURN, 0B
              ENDIF ELSE MESSAGE, 'Case not implemented'
           ENDIF ELSE BEGIN
              IF NOT PTR_VALID(a[j]) AND PTR_VALID(b[j]) THEN RETURN, 0B
              IF PTR_VALID(a[j]) AND NOT PTR_VALID(b[j]) THEN RETURN, 0B
           ENDELSE
        ENDIF ELSE MESSAGE, 'Case not implemented'
     ENDIF 
     
     IF ((typa GE 8) AND (typb NE typa)) THEN RETURN, 0B
     IF ((typb GE 8) AND (typb NE typa)) THEN RETURN, 0B
     
     IF ((typa EQ 8) AND (typb EQ 8)) THEN BEGIN
        ;; IF NOT STRUCT_EQUAL(a,b) THEN RETURN, 0B
        PSM_DEBUG_MESSAGE, 'Check this', routine='ARRAYS_EQUAL'
        IF NOT STRUCT_EQUAL(a,b) THEN RETURN, 0B
     ENDIF
     
     IF ((typa EQ 7) AND (typb NE 7)) THEN RETURN, 0B
     IF ((typa NE 7) AND (typb EQ 7)) THEN RETURN, 0B
     
     IF NOT (a[j] EQ b[j]) THEN RETURN, 0B
     
  ENDFOR
  
  RETURN, 1B
  
END	
