; -----------------------------------------------------------------------------
;
; Copyright (C) 2011
;   Jacques Delabrouille
;   Matthieu Roman
;
; This file is part of the Planck Sky Model (PSM).
;
; The Planck Sky Model is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; The Planck Sky Model is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with the Planck Sky Model.  If not, see <http://www.gnu.org/licenses/>.
;
; For more information about the PSM see:
; http://www.apc.univ-paris7.fr/~delabrou/PSM/psm.html
; or contact Jacques Delabrouille (delabrouille@apc.univ-paris7.fr)
;
; -----------------------------------------------------------------------------
;+
; NAME:
;	GROUP_ADJACENT_PIXELS
;
; PURPOSE:
;	...
;
;-
PRO FIND_NEW_GROUP, pixels, groups, sublist, nside=nside, ordering=ordering

  nel = N_ELEMENTS(pixels)
  ig = MAX(groups)+1L
  wh = WHERE(groups EQ -1, nwh)
  groups[wh[0]] = ig

  sublist = [wh[0]]
  i=0

  WHILE i NE N_ELEMENTS(sublist) DO BEGIN
     HEALPIX_NEIGHBOURS, pixels[sublist[i]], voisins, nside=nside, ordering=ordering
     keep = BYTARR(N_ELEMENTS(voisins))
     FOR j=0, N_ELEMENTS(voisins) -1 DO BEGIN 
        wh = WHERE(pixels EQ voisins[j], nwh)
        IF nwh EQ 1 THEN BEGIN
           IF groups[wh[0]] EQ -1 THEN BEGIN
              keep[j] = 1B
              sublist = [sublist, wh]
              groups[wh] = ig
           ENDIF
        ENDIF
     ENDFOR
     i=i+1
  ENDWHILE

END

PRO GROUP_ADJACENT_PIXELS, pixels, groups, nside=nside, ordering=ordering

  nel = N_ELEMENTS(pixels)
  IF nel EQ 0 THEN MESSAGE, 'pixels not defined'

  groups = REPLICATE(-1L,nel)
  IF nel EQ 1 THEN RETURN

  w = WHERE(groups EQ -1, nw)
  WHILE nw NE 0 DO BEGIN
     FIND_NEW_GROUP, pixels, groups, sublist, nside=nside, ordering=ordering
     w = WHERE(groups EQ -1, nw)
  ENDWHILE

END

