FUNCTION HPX_FACE_PIX, nside, face=face, ordering=ordering, ring=ring

  IF NOT KEYWORD_SET(face) THEN face=0
  IF NOT KEYWORD_SET(ordering) THEN BEGIN
     IF NOT KEYWORD_SET(ring) THEN ordering='NESTED' ELSE ordering='RING'
  ENDIF

  IF nside EQ 1 THEN BEGIN
     RETURN, face
  ENDIF ELSE BEGIN

     ;; Create first subdivision
     ;;--------------------------
     tmpnside = 2
     subpix = [[2,0],[3,1]]
     
     ;; Enlarge if necessary
     ;;----------------------
     WHILE tmpnside LT nside DO BEGIN
        tmpnside = tmpnside*2L
        pix = LONARR(tmpnside,tmpnside)
        pix[0:tmpnside/2-1,0:tmpnside/2-1] = subpix + 2L*(tmpnside^2)/4L
        pix[tmpnside/2:tmpnside-1,tmpnside/2:tmpnside-1] = subpix + (tmpnside^2)/4L
        pix[0:tmpnside/2-1,tmpnside/2:tmpnside-1] = subpix + 3L*(tmpnside^2)/4L
        pix[tmpnside/2:tmpnside-1,0:tmpnside/2-1] = subpix 
        subpix = TEMPORARY(pix)
     ENDWHILE
     
     subpix = TEMPORARY(subpix) + face*(LONG(nside))^2
     
     IF STRUPCASE(ordering) EQ 'RING' THEN BEGIN
        NEST2RING, nside, TEMPORARY(subpix), subpix
        subpix = REFORM(TEMPORARY(subpix), nside, nside)
     ENDIF
     
     RETURN, subpix

  ENDELSE
  
END	 
