; -----------------------------------------------------------------------------
;
; Copyright (C) 2010, 2011
;   Jacques Delabrouille
;
; This file is part of the Planck Sky Model (PSM).
;
; The Planck Sky Model is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; The Planck Sky Model is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with the Planck Sky Model.  If not, see <http://www.gnu.org/licenses/>.
;
; For more information about the PSM see:
; http://www.apc.univ-paris7.fr/~delabrou/PSM/psm.html
; or contact Jacques Delabrouille (delabrouille@apc.univ-paris7.fr)
;
; -----------------------------------------------------------------------------
;+
; NAME:
;	HPX_PIXSMOOTHING
;
; PURPOSE:
;	...
;
;-

PRO HPX_PIXSMOOTHING, map, smoothmap, maxremote=maxremote, ordering=ordering, nocentralpix=nocentralpix, silent=silent, help=help
  
  IF NOT KEYWORD_SET(maxremote) THEN n=1 ELSE n=LONG(maxremote>1)

  weights = REPLICATE(1.,n+1) & FOR r=1L,n DO weights[r] = 8.*r
  IF KEYWORD_SET(nocentralpix) NE 0 THEN weights[0]=0
  kernelpix = REPLICATE(1./TOTAL(weights),n+1)
  HPX_PIX_CONVOL, map, smoothmap, kernelpix=kernelpix, ordering=ordering, silent=silent

END




;; PRO GET_HEALPIX_NEIGHBOURS, i, neighbours, nside=nside, ordering=ordering, radius_in=radius_in, radius_exclude=radius_exclude, nocentralpix=nocentralpix

;;   IF NOT KEYWORD_SET(radius_in) THEN BEGIN
;;      HEALPIX_NEIGHBOURS, i, neighbours, nside=nside, ordering=ordering
;;      IF NOT KEYWORD_SET(nocentralpix) THEN neighbours = [neighbours,i]
;;   ENDIF ELSE BEGIN
;;      CASE ordering OF
;;         'RING': BEGIN
;;            PIX2VEC_RING, nside, i, vec
;;            QUERY_DIST, nside, vec, radius_in, neighbours, nlist, distpix
;;            wh = WHERE(distpix GE radius_exclude, nwh)
;;            IF nwh NE 0 THEN neighbours=neighbours[wh] ELSE MESSAGE, 'No neighbours found within expected distance range'
;;         END
;;         'NESTED': BEGIN
;;            PIX2VEC_NEST, nside, i, vec
;;            QUERY_DIST, nside, vec, radius_in, neighbours, nlist, distpix, /nested
;;            wh = WHERE(distpix GE radius_exclude, nwh)
;;            IF nwh NE 0 THEN neighbours=neighbours[wh] ELSE MESSAGE, 'No neighbours found within expected distance range'
;;         END
;;      ENDCASE
;;      IF KEYWORD_SET(nocentralpix) NE 0 THEN BEGIN
;;         wh = WHERE(neighbours NE i, nwh)
;;         neighbours = neighbours[wh]
;;      ENDIF
;;   ENDELSE

;; END


;; PRO HPX_NEIGHBOUR_SMOOTHING, map, smoothmap, ordering=ordering, max_dist=max_dist, min_dist=min_dist, badexists=badexists, nocentralpix=nocentralpix, total=total

;;   IF NOT KEYWORD_SET(ordering) THEN ordering='RING'
;;   smoothmap = map
;;   nside = GET_NSIDE(map)
;;   pixsize = NSIDE2PIXSIZE(nside, /rad)
;;   IF KEYWORD_SET(max_dist) NE 0 THEN BEGIN
;;      radius_in = max_dist * pixsize                 ; in radians, 0.5 added to count the radius of the central pixel
;;      IF NOT DEFINED(min_dist) THEN radius_exclude=0. ELSE $
;;      radius_exclude = min_dist * pixsize            ; in radians, 0.5 added to count the radius of the central pixel
;;   ENDIF

;;   IF NOT KEYWORD_SET(total) THEN BEGIN
;;      IF NOT KEYWORD_SET(badexists) THEN BEGIN
;;         FOR i=0L, N_ELEMENTS(map)-1 DO BEGIN
;;            GET_HEALPIX_NEIGHBOURS, i, neighbours, nside=nside, ordering=ordering, radius_in=radius_in, radius_exclude=radius_exclude, nocentralpix=nocentralpix
;;            ;IF NOT KEYWORD_SET(nocentralpix) THEN BEGIN
;;            ;   smoothmap[i] = (map[i]+TOTAL(map[neighbours]))/(N_ELEMENTS(neighbours)+1)
;;            ;ENDIF ELSE BEGIN
;;               smoothmap[i] = (TOTAL(map[neighbours]))/(N_ELEMENTS(neighbours))
;;            ;ENDELSE
;;         ENDFOR
;;      ENDIF ELSE BEGIN
;;         FOR i=0L, N_ELEMENTS(map)-1 DO BEGIN
;;            GET_HEALPIX_NEIGHBOURS, i, neighbours, nside=nside, ordering=ordering, radius_in=radius_in, radius_exclude=radius_exclude, nocentralpix=nocentralpix
;;            ;IF NOT KEYWORD_SET(nocentralpix) THEN allpix = [neighbours,i] ELSE allpix = neighbours
;;            ;values = map[allpix]
;;            values = map[neighbours]
;;            whok = WHERE(values NE !healpix.bad_value, nwhok)
;;            IF nwhok NE 0 THEN smoothmap[i] = TOTAL(values[whok])/nwhok ELSE smoothmap[i] = !healpix.bad_value
;;         ENDFOR
;;      ENDELSE
;;   ENDIF ELSE BEGIN
;;      IF NOT KEYWORD_SET(badexists) THEN BEGIN
;;         FOR i=0L, N_ELEMENTS(map)-1 DO BEGIN
;;            GET_HEALPIX_NEIGHBOURS, i, neighbours, nside=nside, ordering=ordering, radius_in=radius_in, radius_exclude=radius_exclude, nocentralpix=nocentralpix
;;            ;IF NOT KEYWORD_SET(nocentralpix) THEN BEGIN
;;            ;   smoothmap[i] = map[i] + TOTAL(map[neighbours])
;;            ;ENDIF ELSE BEGIN
;;               smoothmap[i] = TOTAL(map[neighbours])
;;            ;ENDELSE
;;         ENDFOR
;;      ENDIF ELSE BEGIN
;;         FOR i=0L, N_ELEMENTS(map)-1 DO BEGIN
;;            GET_HEALPIX_NEIGHBOURS, i, neighbours, nside=nside, ordering=ordering, radius_in=radius_in, radius_exclude=radius_exclude, nocentralpix=nocentralpix
;;            ;IF NOT KEYWORD_SET(nocentralpix) THEN allpix = [neighbours,i] ELSE allpix = neighbours
;;            ;values = map[allpix]
;;            values = map[neighbours]
;;            whnotok = WHERE(values EQ !healpix.bad_value, nwhnotok)
;;            IF nwhnotok EQ 0 THEN smoothmap[i] = TOTAL(values) ELSE smoothmap[i] = !healpix.bad_value
;;         ENDFOR
;;      ENDELSE
;;   ENDELSE

;; END

;; PRO HPX_PIXSMOOTHING, map, smoothmap, ordering=ordering, max_dist=max_dist, min_dist=min_dist, niter=niter, help=help, nocentralpix=nocentralpix, total=total

;;   IF KEYWORD_SET(help) NE 0 THEN BEGIN
;;      PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
;;      PRINT, 'HPX_PIXSMOOTHING: procedure to smooth a healpix map in pixel space'
;;      PSM_INFO_MESSAGE, 'SYNTAX: HPX_PIXSMOOTHING, map, smoothmap, ordering=, niter='
;;      PSM_INFO_MESSAGE, "'map' is the input healpix maps"
;;      PSM_INFO_MESSAGE, "'smoothmap' is the output smoothed healpix maps"
;;      PSM_INFO_MESSAGE, "'ordering' is the ordering of input and output maps"
;;      PSM_INFO_MESSAGE, "Normally, for each pixel p, the procedure finds all healpix neighbours (usually 8), the average of p"
;;      PSM_INFO_MESSAGE, "and of all its neighbours is assigned to smoothmap[p], neglecting any bad value."
;;      PSM_INFO_MESSAGE, "If however the keyword 'max_dist' is set to a non-zero number, the code finds pixels"
;;      PSM_INFO_MESSAGE, "within a distance of 'max_dist' of the center of the central one (in units of average pixel size)."
;;      PSM_INFO_MESSAGE, "If 'max_dist' is set to a non-zero number AND 'min_dist' is set also, the code finds pixels"
;;      PSM_INFO_MESSAGE, "between 'min_dist' and 'max_dist' of the central one, in units of average pixel size."
;;      PSM_INFO_MESSAGE, "'niter' sets the number of iterations of the procedure (done 1+niter times)"
;;      PSM_INFO_MESSAGE, "Set /nocentralpix to compute average only over neighbouring pixels, discarding the central one"
;;      PSM_INFO_MESSAGE, "Set /total to return the sum rather than the average"
;;      PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
;;      RETURN
;;   ENDIF

;;   ;; Check for bad values
;;   ;;----------------------
;;   wh = WHERE(map EQ !healpix.bad_value, nwh)
;;   IF nwh NE 0 THEN badexists = 1 ELSE badexists = 0

;;   HPX_NEIGHBOUR_SMOOTHING, map, smoothmap, ordering=ordering, max_dist=max_dist, min_dist=min_dist, badexists=badexists, nocentralpix=nocentralpix, total=total
;;   IF KEYWORD_SET(niter) NE 0 THEN FOR i=1,niter DO BEGIN
;;      HPX_NEIGHBOUR_SMOOTHING, TEMPORARY(smoothmap), smoothmap, ordering=ordering, max_dist=max_dist, min_dist=min_dist, badexists=badexists, nocentralpix=nocentralpix, total=total
;;   ENDFOR

;; END
