FUNCTION RESOL2NSIDE, resol, npixperfwhm = npixperfwhm

  IF NOT KEYWORD_SET(npixperfwhm) THEN BEGIN

     lmax = RESOL2LMAX(resol) 
     ns = (lmax+1)/3.
     ns = 2L * LOWER_POWEROF2(ns)
     RETURN, ns

  ENDIF ELSE BEGIN

     idealpixsize = (resol/DOUBLE(npixperfwhm))/60d0*(!DPI/180D0)        ;in radians	
     nidealpix = 4d0*!DPI/idealpixsize^2
     idealnside = SQRT(nidealpix/12d0)
     exponentof2 = ALOG2(idealnside)
     exponentof2 = ROUND(exponentof2)
     RETURN, 2L^exponentof2

  ENDELSE
     
END
