; -----------------------------------------------------------------------------
;
; Copyright (C) 2011-2012
;   Guillaume Castex
;   Jacques Delabrouille
;
; This file is part of the Planck Sky Model (PSM).
;
; The Planck Sky Model is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; The Planck Sky Model is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with the Planck Sky Model.  If not, see <http://www.gnu.org/licenses/>.
;
; For more information about the PSM see:
; http://www.apc.univ-paris7.fr/~delabrou/PSM/psm.html
; or contact Jacques Delabrouille (delabrouille@apc.univ-paris7.fr)
;
; -----------------------------------------------------------------------------
;+
; NAME:
;	BESSEL_SPH
;
; PURPOSE:
;	Software being developed, not to be used.
;
;-
FUNCTION BESSEL_SPH, X, N

;; Bessel spherical function
;; j_n(x) returns the value at x (can be an array) for bessel function
;; of order n (real if positive or integer if negative).
;; JD: note that there is a call to BESELJ(X,N+0.5) which means that
;; for N less than -0.5 allowed values are -1.5, -2.5, etc... to be checked.

  PSM_DEBUG_MESSAGE, 'Code needs validation and documentation', routine=BESSEL_SPH
  jn = SQRT(!dpi/2.)*BESELJ(X,N+0.5)/SQRT(X)

  RETURN, jn
END
