; -----------------------------------------------------------------------------
;
; Copyright (C) 2009, 2012
;   Jacques Delabrouille
;
; This file is part of the Planck Sky Model (PSM).
;
; The Planck Sky Model is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; The Planck Sky Model is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with the Planck Sky Model.  If not, see <http://www.gnu.org/licenses/>.
;
; For more information about the PSM see:
; http://www.apc.univ-paris7.fr/~delabrou/PSM/psm.html
; or contact Jacques Delabrouille (delabrouille@apc.univ-paris7.fr)
;
; -----------------------------------------------------------------------------
;+
; NAME:
;	CL2COVAR
;
; PURPOSE:
;	...
;
;-
PRO CL2COVAR, cl, l, covar, help=help

  IF KEYWORD_SET(help) NE 0 THEN BEGIN
     PRINT, ''
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     PRINT, 'CL2COVAR: procedure to extract the covariance matrix at a given l from a cl structure'
     PSM_INFO_MESSAGE, 'SYNTAX: CL2COVAR, cl, l, covar'
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     RETURN
  ENDIF

  nx = N_ELEMENTS(cl.field)
  covar = REPLICATE(0B*cl.c_1_1[0],nx*nx)
  covar = REFORM(covar,nx,nx)
  FOR i=0, nx-1 DO FOR j=i, nx-1 DO BEGIN
     ok = EXECUTE('covar[i,j] = cl.c_' +NUMBER2STRING(i+1)+ '_' +NUMBER2STRING(j+1)+'[l]')
     IF NOT ok THEN MESSAGE, 'Could not execute command'
     covar[j,i] = covar[i,j]
  ENDFOR
  
END
