; -----------------------------------------------------------------------------
;
; Copyright (C) 2009
;   Jacques Delabrouille
;
; This file is part of the Planck Sky Model (PSM).
;
; The Planck Sky Model is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; The Planck Sky Model is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with the Planck Sky Model.  If not, see <http://www.gnu.org/licenses/>.
;
; For more information about the PSM see:
; http://www.apc.univ-paris7.fr/~delabrou/PSM/psm.html
; or contact Jacques Delabrouille (delabrouille@apc.univ-paris7.fr)
;
; -----------------------------------------------------------------------------
;+
; NAME:
;	STR_MATCH
;
; PURPOSE:
;	...
;
;-
FUNCTION SINGLE_STR_MATCH,  str, searchstring

  search = 1
  begin_string = ''
  endstring = str
  nmatch = 0
  WHILE search EQ 1 DO BEGIN
     whout = STRPOS(endstring,searchstring)
     IF whout EQ -1 THEN BEGIN
        search = 0
        RETURN, nmatch
     ENDIF ELSE BEGIN
        nmatch = nmatch+1
        endstring = STRMID(endstring,whout+STRLEN(searchstring))
     ENDELSE
  ENDWHILE
END

FUNCTION STR_MATCH, str, searchstring

IF ( N_PARAMS() EQ 0 ) THEN BEGIN
   print,'  CALL IS : result = STR_MATCH(str, searchstring)'
   GOTO, closing
ENDIF

string_is_an_array = ISARRAY(str)

IF string_is_an_array THEN BEGIN
   nstr = N_ELEMENTS(str)
   nnn = INTARR(nstr)
   FOR i=0, nstr-1 DO nnn[i] = SINGLE_STR_MATCH(str[i],searchstring)
ENDIF ELSE nnn = SINGLE_STR_MATCH(str,searchstring)

RETURN, nnn
closing:
END
