; -----------------------------------------------------------------------------
;
; Copyright (C) 2010, 2012
;   Jacques Delabrouille
;
; This file is part of the Planck Sky Model (PSM).
;
; The Planck Sky Model is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; The Planck Sky Model is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with the Planck Sky Model.  If not, see <http://www.gnu.org/licenses/>.
;
; For more information about the PSM see:
; http://www.apc.univ-paris7.fr/~delabrou/PSM/psm.html
; or contact Jacques Delabrouille (delabrouille@apc.univ-paris7.fr)
;
; -----------------------------------------------------------------------------
;+
; NAME:
;	WACTIVE
;
; PURPOSE:
;	...
;
;-
PRO WACTIVE, n, help=help

  IF KEYWORD_SET(help) NE 0 THEN BEGIN
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     PRINT, 'WACTIVE: procedure to get and print number of all active (open) windows'
     PSM_INFO_MESSAGE, 'SYNTAX: WACTIVE, n'
     PSM_INFO_MESSAGE, "n is the (output) number of active window(s) [optionnal]"
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     RETURN
  ENDIF

  ;; Check that X windows device is used
  ;;-------------------------------------
  IF (!d.name NE 'X') THEN BEGIN
     MESSAGE, 'DEVICE not set to X Windows.', /info
     RETURN
  ENDIF

  ;; Find active (open) windows
  ;;----------------------------
  DEVICE, window_state = openwindows
  n = WHERE(openwindows,Nopen)
  IF (Nopen EQ 0) $
  THEN MESSAGE, 'No window open', /info $
  ELSE MESSAGE, 'Windows active: '+STRJOIN(STRTRIM(n,2),' '), /info

END


